import sys
from sshkeyboard import listen_keyboard
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BOARD)                    # setup GPIO
GPIO.setwarnings(False)

GPIO.setup(8, GPIO.OUT, initial=GPIO.LOW)   # pins for motor 1
GPIO.setup(10, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(12, GPIO.OUT)

GPIO.setup(24, GPIO.OUT, initial=GPIO.LOW)  # pins for motor 2
GPIO.setup(26, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(32, GPIO.OUT)

p1 = GPIO.PWM(12,100)                       # channel=12 frequency=100Hz
p1.start(0)                                 # start at 0 duty cycle
duty1 = 0

p2 = GPIO.PWM(32,100)                       # channel=32 frequency=100Hz
p2.start(0)                                 # start at 0 duty cycle
duty2 = 0

print("w and s controls motor 1")
print("e and d controls motor 2")

def motor1(duty):
    if duty > 0:                            # determine direction
        GPIO.output(8, GPIO.HIGH)
        GPIO.output(10, GPIO.LOW)
    else:
        GPIO.output(8, GPIO.LOW)
        GPIO.output(10, GPIO.HIGH)
    p1.ChangeDutyCycle(abs(duty))           # change duty cycle
    print("motor 1: " + str(duty))

def motor2(duty):
    if duty > 0:                            # determine direction
        GPIO.output(24, GPIO.HIGH)
        GPIO.output(26, GPIO.LOW)
    else:
        GPIO.output(24, GPIO.LOW)
        GPIO.output(26, GPIO.HIGH)
    p2.ChangeDutyCycle(abs(duty))           # change duty cycle
    print("motor 2: " + str(duty))

def press(key):
    global duty1, duty2

    if key == "w":
        if duty1 < 100:
            duty1 += 10
            motor1(duty1)

    elif key == "s":
        if duty1 > -100:
            duty1 -= 10
            motor1(duty1)

    if key == "e":
        if duty2 < 100:
            duty2 += 10
            motor2(duty2)

    elif key == "d":
        if duty2 > -100:
            duty2 -= 10
            motor2(duty2)

listen_keyboard(
    on_press=press,
    delay_second_char = 0.05
)

p1.stop()
p2.stop()
del p1
del p2
GPIO.cleanup()
